VERSION 5.00
Begin VB.UserControl Tray 
   CanGetFocus     =   0   'False
   ClientHeight    =   510
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   510
   InvisibleAtRuntime=   -1  'True
   Picture         =   "Tray.ctx":0000
   ScaleHeight     =   34
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   34
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "Tray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'  -    
'  ! !  :)

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As NotifyIconMessage, lpData As NOTIFYICONDATA) As Long

Private Enum NotifyIconMessage
  NIM_ADD = &H0&
  NIM_MODIFY = &H1&
  NIM_DELETE = &H2&
End Enum

Private Enum TrayMouseEvents
  trayOver = &H200&
  trayLeftDown = &H201&
  trayLeftUp = &H202&
  trayLeftDoubleClick = &H203&
  trayRightDown = &H204&
  trayRightUp = &H205&
  trayRightDoubleClick = &H206&
  trayMiddleDown = &H207&
  trayMiddleUp = &H208&
End Enum

Public Enum TrayIconFlags
  NIF_MESSAGE = &H1&
  NIF_ICON = &H2&
  NIF_TIP = &H4&
End Enum

Private Type NOTIFYICONDATA
  cbSize As Long
  hWnd As Long
  uID As Long
  uFlags As TrayIconFlags
  uCallbackMessage As Long
  hIcon As Long
  szTip As String * 64
End Type

Public Event DoubleClick(ByVal Button As MouseButtonConstants, ByVal Shift As ShiftConstants)
Public Event MouseMove(ByVal Shift As ShiftConstants)
Public Event MouseDown(ByVal Button As MouseButtonConstants, ByVal Shift As ShiftConstants)
Public Event MouseUp(ByVal Button As MouseButtonConstants, ByVal Shift As ShiftConstants)

Private mInTray As Boolean
Private mIconData As NOTIFYICONDATA
Private mImages() As New StdPicture
Private mCurrentPicture As Long

Private ret As Long

Private Sub Timer1_Timer()
  '      
  mCurrentPicture = mCurrentPicture + 1
  If mCurrentPicture > UBound(mImages) Then mCurrentPicture = 1
  mIconData.hIcon = mImages(mCurrentPicture)
  UpdateMe
End Sub

Private Sub UserControl_Initialize()
  ', ,  ...
  mIconData.cbSize = Len(mIconData)
  mIconData.hWnd = UserControl.hWnd
  mIconData.uCallbackMessage = trayLeftUp
  mIconData.uFlags = NIF_MESSAGE Or NIF_TIP Or NIF_ICON
  ReDim mImages(1 To 1)
  mCurrentPicture = 1
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  ToolTip = PropBag.ReadProperty("ToolTip", vbNullString)
  Timer1.Interval = PropBag.ReadProperty("TimerInterval", 0)
  ID = PropBag.ReadProperty("ID", 0)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "ToolTip", ToolTip, vbNullString
  PropBag.WriteProperty "TimerInterval", Timer1.Interval, 0
  PropBag.WriteProperty "ID", mIconData.uID, 0
End Sub

Private Sub UserControl_Resize()
  ' ,   
  UserControl.Width = 510
  UserControl.Height = 510
End Sub

Private Sub HandleError()
  If ret = 0 Then Err.Raise Err.LastDllError, Name
End Sub

Property Get InTray() As Boolean
Attribute InTray.VB_MemberFlags = "400"
  InTray = mInTray
End Property

Property Let InTray(ByVal IsIt As Boolean)
  '\  \ 
  If IsIt = mInTray Then Exit Property
  
  If IsIt Then
    ret = Shell_NotifyIcon(NIM_ADD, mIconData)
  Else
    ret = Shell_NotifyIcon(NIM_DELETE, mIconData)
  End If
  HandleError
  mInTray = IsIt
End Property

Property Get PicturesCount() As Long
  '   ?
  PicturesCount = UBound(mImages)
End Property

Property Get Picture(Optional ByVal Index As Long = 1) As IPictureDisp
Attribute Picture.VB_MemberFlags = "400"
  Set Picture = mImages(Index)
End Property

Property Set Picture(Optional ByVal Index As Long = 1, Pic As IPictureDisp)
  '   N
  If Pic.Type = vbPicTypeIcon Then
    If Index > UBound(mImages) Then ReDim Preserve mImages(1 To Index)
    Set mImages(Index) = Pic
    If Not Timer1.Enabled And mCurrentPicture = Index Then mIconData.hIcon = mImages(mCurrentPicture): UpdateMe
  End If
End Property

Property Get CurrentPicture() As Long
  '     ...
  CurrentPicture = mCurrentPicture
End Property

Property Let CurrentPicture(ByVal CP As Long)
  If Not Ambient.UserMode Then Exit Property
  '  ,    
  If CP > UBound(mImages) Then mCurrentPicture = UBound(mImages) Else mCurrentPicture = CP
  mIconData.hIcon = mImages(mCurrentPicture): UpdateMe
End Property

Property Get TimerInterval() As Long
  TimerInterval = Timer1.Interval
End Property

Property Let TimerInterval(ByVal TI As Long)
  '  ...
  Timer1.Interval = TI
End Property

Property Get TimerEnabled() As Boolean
Attribute TimerEnabled.VB_MemberFlags = "400"
  TimerEnabled = Timer1.Enabled
End Property

Property Let TimerEnabled(ByVal TE As Boolean)
  '  ...
  Timer1.Enabled = TE
End Property

Property Get ID() As Long
  ID = mIconData.uID
End Property

Property Let ID(ByVal i As Long)
  '  .
  mIconData.uID = i
  UpdateMe
End Property

Property Get Flags() As TrayIconFlags
Attribute Flags.VB_MemberFlags = "400"
  Flags = mIconData.uFlags
End Property

Property Let Flags(ByVal f As TrayIconFlags)
  '   ...
  mIconData.uFlags = f
  UpdateMe
End Property

Property Get ToolTip() As String
  On Error Resume Next
  ToolTip = Left$(mIconData.szTip, InStr(mIconData.szTip, vbNullChar) - 1)
End Property

Property Let ToolTip(ByVal TT As String)
  ',  ...
  mIconData.szTip = TT + vbNullChar
  UpdateMe
End Property

Private Sub UpdateMe()
  If mInTray Then
    ret = Shell_NotifyIcon(NIM_MODIFY, mIconData)
    HandleError
  End If
End Sub

Private Sub UserControl_Terminate()
  On Local Error Resume Next
  Timer1.Enabled = False
  Erase mImages
  Shell_NotifyIcon NIM_DELETE, mIconData
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  ',  .   ,    , 
  '    ,   .
  '   ,   mIconData.hWnd  
  'hWnd .
  '  mIconData.uCallbackMessage  trayLeftUp. ,
  '    
  '   ,    WM_LBUTTONUP,  
  '  UserControl_MouseUp.
  '  - VB  . - ,  
  '   .   X  Y   ,
  '   ,      vbPixels   ScaleMode.
  '  UserControl.ScaleMode=vbPixels.
    
  'Shift  -   shift, ctrl, alt
  'X      -  ,    (  TrayMouseEvents)
  If Ambient.UserMode Then
    Select Case X
      Case trayOver:             RaiseEvent MouseMove(Shift)
      Case trayLeftDown:         RaiseEvent MouseDown(vbLeftButton, Shift)
      Case trayRightDown:        RaiseEvent MouseDown(vbRightButton, Shift)
      Case trayMiddleDown:       RaiseEvent MouseDown(vbMiddleButton, Shift)
      Case trayLeftUp:           RaiseEvent MouseUp(vbLeftButton, Shift)
      Case trayRightUp:          RaiseEvent MouseUp(vbRightButton, Shift)
      Case trayMiddleUp:         RaiseEvent MouseUp(vbMiddleButton, Shift)
      Case trayLeftDoubleClick:  RaiseEvent DoubleClick(vbLeftButton, Shift)
      Case trayRightDoubleClick: RaiseEvent DoubleClick(vbRightButton, Shift)
    End Select
  End If
End Sub

